# -*- coding: utf-8 -*-
import json
try:
    from urllib2 import urlopen
except ImportError:
    from urllib.request import urlopen
try:
    from urllib import quote
except ImportError:
    from urllib.parse import quote


def gethttp(url):
    return urlopen(url).read().decode('utf-8')


def getjson(url):
    return json.loads(gethttp(url))


def category(cat, page=1):
    url = 'http://vod.tian-le.com/api.php?ac=recent&tp=%s&pg=%d' % (quote(cat), page)
    try:
        data = getjson(url)
    except Exception as e:
        return {'code': 'vod 300', 'error': str(e)}
    ret = content(data)
    if len(ret) == 30:
        ret.append({'title': 'Next Page (%d)' % (page + 1), 'category': cat, 'page': page + 1})
    return ret


def search(s, page=1):
    url = 'http://vod.tian-le.com/api.php?ac=search&q=%s&pg=%d' % (quote(s), page)
    try:
        data = getjson(url)
    except Exception as e:
        return {'code': 'vod 400', 'error': str(e)}
    ret = content(data)
    if len(ret) == 30:
        ret.append({'title': 'Next Page (%d)' % (page + 1), 'search': s, 'page': page + 1})
    return ret


def content(data):
    ret = []
    for e in data:
        plot = []
        plot.append(u'更新：%s' % e['ts'])
        if e['stat']:
            plot.append(u'状态：%s' % e['stat'])
        if e['cls']:
            plot.append(u'类型：%s' % e['cls'])
        if e['reg']:
            plot.append(u'地区：%s' % e['reg'])
        if e['yr']:
            plot.append(u'年份：%s' % e['yr'])
        if e['lang']:
            plot.append(u'语言：%s' % e['lang'])
        if e['num']:
            plot.append(u'集数：%s' % e['num'])
        if e['rt']:
            plot.append(u'时长：%s' % e['rt'])
        if e['drt']:
            plot.append(u'导演：%s' % e['drt'])
        if e['act']:
            plot.append(u'主演：%s' % e['act'])
        if e['intro']:
            plot.append(e['intro'])
        plot = '\n'.join(plot)
        ret1 = []
        for e1 in e['m3u8']:
            k1 = list(e1.keys())[0]
            v1 = list(e1.values())[0]
            ret2 = []
            for e2 in v1:
                ret2.append({e2['nm']: e2['url']})
            ret1.append({k1: ret2})
        if len(ret1) == 1:
            ret1 = list(ret1[0].values())[0]
        if len(ret1) == 1:
            ret.append({'title': e['nm'] + ' ' + e['site_nm'] + ' ' + e['id'], 'img': e['img'], 'url': list(ret1[0].values())[0], 'plot': plot})
        else:
            ret.append({'title': e['nm'] + ' ' + e['site_nm'] + ' ' + e['id'], 'img': e['img'], 'json': json.dumps(ret1), 'plot': plot})
    return ret
